export function getTransformation(prototype, attributeName) {
    const prototypeMap = getPrototypeMap();
    while (true) {
        const transformation = prototypeMap.get(prototype)?.get(attributeName);
        if (transformation) {
            return transformation;
        }
        const parentPrototype = Object.getPrototypeOf(prototype);
        if (!parentPrototype) {
            return undefined;
        }
        prototype = parentPrototype;
    }
}
export function setTransformation(prototype, attributeName, transformation) {
    const prototypeMap = getPrototypeMap();
    let attributeTransformationMap = prototypeMap.get(prototype);
    if (!attributeTransformationMap) {
        attributeTransformationMap = new Map();
        prototypeMap.set(prototype, attributeTransformationMap);
    }
    attributeTransformationMap.set(attributeName, transformation);
}
function getPrototypeMap() {
    let prototypeMap = globalThis.__transformablePrototypeMap;
    if (prototypeMap === undefined) {
        prototypeMap = new WeakMap();
        globalThis.__transformablePrototypeMap = prototypeMap;
    }
    return prototypeMap;
}
//# sourceMappingURL=storage.js.map